import enum

from puyapy import UInt64

@enum.unique
class OnCompleteAction(UInt64, enum.ReprEnum):
    NoOp = ...

    OptIn = ...
    """OptIn indicates that an application transaction will allocate some
    LocalState for the application in the sender's account"""

    CloseOut = ...
    """CloseOut indicates that an application transaction will deallocate
    some LocalState for the application from the user's account"""

    ClearState = ...
    """ClearState is similar to CloseOut, but may never fail. This
    allows users to reclaim their minimum balance from an application
    they no longer wish to opt in to."""

    UpdateApplication = ...
    """UpdateApplication indicates that an application transaction will
    update the ApprovalProgram and ClearStateProgram for the application"""

    DeleteApplication = ...
    """DeleteApplication indicates that an application transaction will
    delete the AppParams for the application from the creator's balance
    record"""

@enum.unique
class TransactionType(UInt64, enum.ReprEnum):
    Payment = ...
    KeyRegistration = ...
    AssetConfig = ...
    AssetTransfer = ...
    AssetFreeze = ...
    ApplicationCall = ...
